Index: roarclients/roar-config.c
===================================================================
--- roarclients/roar-config.c	(revision 4725)
+++ roarclients/roar-config.c	(revision 4885)
@@ -68,4 +68,6 @@
 }
 
+#define _strcat(buf, n) strncat(buf, n, sizeof(buf)-1-strlen(buf))
+
 int main (int argc, char * argv[]) {
  enum { NORMAL, PC } mode = NORMAL;
@@ -121,8 +123,8 @@
     if ( cflags || libs ) {
      if ( cflags )
-      strcat(buf, flags_ptr->cflags);
+      _strcat(buf, flags_ptr->cflags);
 
      if ( libs )
-      strcat(buf, flags_ptr->libs);
+      _strcat(buf, flags_ptr->libs);
 
      puts(buf);
Index: roarclients/roarclientpass.c
===================================================================
--- roarclients/roarclientpass.c	(revision 4708)
+++ roarclients/roarclientpass.c	(revision 4885)
@@ -22,4 +22,8 @@
  *  Boston, MA 02110-1301, USA.
  *
+ */
+
+/* ckport options:
+ * ckport: ignore: ^roar_socket_open$ -- Used to get a clientfh.
  */
 
@@ -123,8 +127,8 @@
   roar_debug_set_stderr_mode(ROAR_DEBUG_MODE_SYSLOG);
 #else
-  roar_debug_set_stderr_fh(-1);
+  roar_debug_set_stderr_vio(roar_stderr);
 #endif
  } else {
-  roar_debug_set_stderr_fh(ROAR_STDERR);
+  roar_debug_set_stderr_vio(roar_stderr);
  }
 
Index: roarclients/roarctl.c
===================================================================
--- roarclients/roarctl.c	(revision 4882)
+++ roarclients/roarctl.c	(revision 4885)
@@ -22,4 +22,8 @@
  *  Boston, MA 02110-1301, USA.
  *
+ */
+
+/* ckport options:
+ * ckport: ignore: ^roar_req$ -- Used within ping command.
  */
 
Index: roarclients/roarinterconnect.c
===================================================================
--- roarclients/roarinterconnect.c	(revision 4708)
+++ roarclients/roarinterconnect.c	(revision 4885)
@@ -22,4 +22,10 @@
  *  Boston, MA 02110-1301, USA.
  *
+ */
+
+/* ckport options:
+ * ckport: ignore: ^roar_cdriver_oss$     -- For OSS streams
+ * ckport: ignore: ^roar_simple_stream$   -- For RoarAudio streams
+ * ckport: ignore: ^roar_socket_connect$  -- For PulseAudio Simple streams
  */
 
Index: roarclients/roarmon.c
===================================================================
--- roarclients/roarmon.c	(revision 4883)
+++ roarclients/roarmon.c	(revision 4885)
@@ -205,5 +205,5 @@
 
  if ( prethru ) {
-  if ( roar_stream_set_flags(&con, &s, ROAR_FLAG_PRETHRU, 0) == -1 ) {
+  if ( roar_stream_set_flags2(&con, &s, ROAR_FLAG_PRETHRU, ROAR_SET_FLAG) == -1 ) {
    fprintf(stderr, "Error: can not set prethru flag on stream\n");
    roar_disconnect(&con);
Index: roarclients/roarmonhttp.c
===================================================================
--- roarclients/roarmonhttp.c	(revision 4883)
+++ roarclients/roarmonhttp.c	(revision 4885)
@@ -347,5 +347,5 @@
 
  if ( sflags != ROAR_FLAG_NONE ) {
-  if ( roar_stream_set_flags(&con, &s, sflags, 0) == -1 ) {
+  if ( roar_stream_set_flags2(&con, &s, sflags, ROAR_SET_FLAG) == -1 ) {
    roar_disconnect(&con);
    return 14;
Index: roarclients/roarshout.c
===================================================================
--- roarclients/roarshout.c	(revision 4757)
+++ roarclients/roarshout.c	(revision 4885)
@@ -105,5 +105,7 @@
  char * s_url    = NULL;
  int    s_public = 0;
- int    fh;
+ roar_vs_t * vss;
+ int    err;
+ ssize_t ret;
  int    i;
  char buf[BUFSIZE];
@@ -252,6 +254,6 @@
   shout_set_url(shout, s_url);
 
- if ( (fh = roar_simple_monitor(rate, channels, bits, codec, server, "roarshout")) == -1 ) {
-  fprintf(stderr, "Error: can not start monitoring\n");
+ if ( (vss = roar_vs_new_simple(server, "roarshout", rate, channels, codec, bits, ROAR_DIR_MONITOR, &err)) == NULL ) {
+  fprintf(stderr, "Error: can not start monitoring: %s\n", roar_vs_strerr(err));
   return 1;
  }
@@ -262,9 +264,9 @@
  }
 
- while((i = read(fh, buf, BUFSIZE)))
+ while((ret = roar_vs_read(vss, buf, BUFSIZE, NULL)))
   if (shout_send(shout, (unsigned char*)buf, i) != SHOUTERR_SUCCESS)
    break;
 
- roar_simple_close(fh);
+ roar_vs_close(vss, ROAR_VS_TRUE, NULL);
 
  shout_sync(shout);
Index: roarclients/roarsin.c
===================================================================
--- roarclients/roarsin.c	(revision 4708)
+++ roarclients/roarsin.c	(revision 4885)
@@ -82,5 +82,6 @@
  float length = 5; /* 5 sec */
  float step;       /* how much time per sample we have to encode ... */
- int fh;
+ roar_vs_t * vss;
+ int err;
  int i;
  int16_t out[1024];
@@ -109,6 +110,6 @@
  step   = M_PI*2*freq/rate;
 
- if ( (fh = roar_simple_play(rate, channels, bits, codec, NULL, "sine gen")) == -1 ) {
-  fprintf(stderr, "Error: can not open playback!\n");
+ if ( (vss = roar_vs_new_playback(NULL, "sine gen", rate, channels, codec, bits, &err)) == NULL ) {
+  fprintf(stderr, "Error: can not open playback: %s\n", roar_vs_strerr(err));
   exit(1);
  }
@@ -119,8 +120,8 @@
    t += step;
   }
-  write(fh, out, 2048);
+  roar_vs_write(vss, out, 2048, NULL);
  }
 
- roar_simple_close(fh);
+ roar_vs_close(vss, ROAR_VS_FALSE, NULL);
 
  return 0;