Index: doc/man3/roar_vs_buffer.3
===================================================================
--- doc/man3/roar_vs_buffer.3	(revision 5057)
+++ doc/man3/roar_vs_buffer.3	(revision 5057)
@@ -0,0 +1,64 @@
+.TH "roar_vs_buffer" "3" "May 2011" "RoarAudio" "RoarAudio Programmer's Manual"
+
+.SH NAME
+roar_vs_buffer \- Use buffered mode streams
+
+.SH SYNOPSIS
+
+#include <roaraudio.h>
+
+int roar_vs_buffer(roar_vs_t * vss, size_t buffer, int * error);
+
+ssize_t roar_vs_get_avail_read(roar_vs_t * vss, int * error);
+
+ssize_t roar_vs_get_avail_write(roar_vs_t * vss, int * error);
+
+int     roar_vs_reset_buffer(roar_vs_t * vss, int writering, int readring, int * error);
+
+.SH "DESCRIPTION"
+These functions controls the buffered mode of the VS object. Using this mode is not recommended.
+
+\fBroar_vs_buffer()\fR initializes the buffered mode. It takes the size for the buffer as argument.
+The size should be a power of two. Common values include 2048 and 4096.
+
+\fBroar_vs_get_avail_read()\fR and \fBroar_vs_get_avail_write()\fR return the amount of free space
+in the read and write buffer.
+
+\fBroar_vs_reset_buffer()\fR resets the read and/or write buffer. This means the data in the buffers is discarded.
+This does not happen frame aligned and may result in broken audio.
+
+Buffers are not flushed automaically. To do this use \fBroar_vs_iterate\fR(3) or \fBroar_vs_run\fR(3).
+
+.SH "PARAMETERS"
+.TP
+\fBvss\fR
+The VS object to be used.
+
+.TP
+\fBbuffer\fR
+The size of the buffer to be used in bytes.
+
+.TP
+\fBwritering\fR, \fBreadring\fR
+Selects the buffer to reset. Must be ROAR_VS_TRUE or ROAR_VS_FALSE.
+
+.TP
+\fBerror\fR
+This is a pointer to a integer used to store the error value in case of error.
+This can be NULL if not used but it is very recommended to use this error value to report
+good error messages to the user.
+
+.SH "RETURN VALUE"
+On success these calls return 0.
+roar_vs_get_avail_read() and roar_vs_get_avail_write() return the free space in the corresponding buffer.
+On error, \-1 is returned.
+
+.SH "EXAMPLES"
+FIXME
+
+.SH "SEE ALSO"
+\fBroarvs\fR(7),
+\fBlibroar\fR(7),
+\fBRoarAudio\fR(7).
+
+.\" ll
Index: doc/man3/roar_vs_iterate.3
===================================================================
--- doc/man3/roar_vs_iterate.3	(revision 5057)
+++ doc/man3/roar_vs_iterate.3	(revision 5057)
@@ -0,0 +1,48 @@
+.TH "roar_vs_iterate" "3" "June 2011" "RoarAudio" "RoarAudio Programmer's Manual"
+
+.SH NAME
+roar_vs_iterate, roar_vs_run \- Iterate streams
+
+.SH SYNOPSIS
+
+#include <roaraudio.h>
+
+int     roar_vs_iterate       (roar_vs_t * vss, int wait, int * error);
+
+int     roar_vs_run           (roar_vs_t * vss, int * error);
+
+.SH "DESCRIPTION"
+\fBroar_vs_iterate()\fR sends a block of data from the local buffer to the server or reads data from the
+server into the local buffer in blocking mode, or pushes or pulls data to or from server in file mode.
+
+\fBroar_vs_run()\fR does the same as roar_vs_iterate() but loops until EOF or error.
+
+.SH "PARAMETERS"
+.TP
+\fBvss\fR
+The VS object to be used.
+
+.TP
+\fBwait\fR
+If ROAR_VS_WAIT roar_vs_iterate() will block until data has been synced with the server.
+If ROAR_VS_NOWAIT roar_vs_iterate() will not block if no data can be send to or read from the server.
+
+.TP
+\fBerror\fR
+This is a pointer to a integer used to store the error value in case of error.
+This can be NULL if not used but it is very recommended to use this error value to report
+good error messages to the user.
+
+.SH "RETURN VALUE"
+On EOF these calls return 0. roar_vs_iterate() returns a positive value on non-EOF success.
+On error, \-1 is returned.
+
+.SH "EXAMPLES"
+FIXME
+
+.SH "SEE ALSO"
+\fBroarvs\fR(7),
+\fBlibroar\fR(7),
+\fBRoarAudio\fR(7).
+
+.\" ll
Index: doc/symlinks.src
===================================================================
--- doc/symlinks.src	(revision 5042)
+++ doc/symlinks.src	(revision 5057)
@@ -19,2 +19,6 @@
 roar_vs_volume_stereo		3	roar_vs_volume_get	3
 roar_vs_mute			3	roar_vs_pause		3
+roar_vs_run			3	roar_vs_iterate		3
+roar_vs_get_avail_read		3	roar_vs_buffer		3
+roar_vs_get_avail_write		3	roar_vs_buffer		3
+roar_vs_reset_buffer		3	roar_vs_buffer		3