Index: include/libroar/ctl.h
===================================================================
--- include/libroar/ctl.h	(revision 4740)
+++ include/libroar/ctl.h	(revision 5109)
@@ -39,17 +39,19 @@
 #include "libroar.h"
 
-int roar_get_clientid  (struct roar_connection * con);
+#define _LIBROAR_CTL_STDATTRS _LIBROAR_ATTR_USE_RESULT _LIBROAR_ATTR_NONNULL_ALL
 
-int roar_get_standby   (struct roar_connection * con);
-int roar_set_standby   (struct roar_connection * con, int state);
+int roar_get_clientid  (struct roar_connection * con) _LIBROAR_CTL_STDATTRS;
 
-int roar_exit           (struct roar_connection * con);
-int roar_terminate      (struct roar_connection * con, int terminate);
-int roar_server_oinfo   (struct roar_connection * con, struct roar_stream * s);
-int roar_server_oinfo2  (struct roar_connection * con, struct roar_stream * s, int dir);
+int roar_get_standby   (struct roar_connection * con) _LIBROAR_CTL_STDATTRS;
+int roar_set_standby   (struct roar_connection * con, int state) _LIBROAR_CTL_STDATTRS;
+
+int roar_exit           (struct roar_connection * con) _LIBROAR_CTL_STDATTRS _LIBROAR_ATTR_DEPRECATED;
+int roar_terminate      (struct roar_connection * con, int terminate) _LIBROAR_CTL_STDATTRS;
+int roar_server_oinfo   (struct roar_connection * con, struct roar_stream * s) _LIBROAR_CTL_STDATTRS _LIBROAR_ATTR_DEPRECATED;
+int roar_server_oinfo2  (struct roar_connection * con, struct roar_stream * s, int dir) _LIBROAR_CTL_STDATTRS;
 
 
-int roar_list         (struct roar_connection * con, int * items,   int max, int cmd);
-int roar_list_filtered(struct roar_connection * con, int * items,   int max, int cmd, unsigned char filter, unsigned char cmp, uint32_t id);
+int roar_list         (struct roar_connection * con, int * items,   int max, int cmd) _LIBROAR_CTL_STDATTRS;
+int roar_list_filtered(struct roar_connection * con, int * items,   int max, int cmd, unsigned char filter, unsigned char cmp, uint32_t id) _LIBROAR_CTL_STDATTRS;
 
 /*
@@ -60,12 +62,12 @@
 #define roar_list_streams(c,i,m) roar_list((c),(i),(m),ROAR_CMD_LIST_STREAMS)
 
-int roar_get_client   (struct roar_connection * con, struct roar_client * client, int id);
-int roar_get_stream   (struct roar_connection * con, struct roar_stream * stream, int id);
+int roar_get_client   (struct roar_connection * con, struct roar_client * client, int id) _LIBROAR_CTL_STDATTRS;
+int roar_get_stream   (struct roar_connection * con, struct roar_stream * stream, int id) _LIBROAR_CTL_STDATTRS;
 
-int roar_kick         (struct roar_connection * con, int type, int id);
+int roar_kick         (struct roar_connection * con, int type, int id) _LIBROAR_CTL_STDATTRS;
 
-int roar_set_vol      (struct roar_connection * con, int id, struct roar_mixer_settings * mixer, int   channels);
-int roar_set_vol2     (struct roar_connection * con, int id, struct roar_mixer_settings * mixer, int   channels, int mode);
-int roar_get_vol      (struct roar_connection * con, int id, struct roar_mixer_settings * mixer, int * channels);
+int roar_set_vol      (struct roar_connection * con, int id, struct roar_mixer_settings * mixer, int   channels) _LIBROAR_CTL_STDATTRS _LIBROAR_ATTR_DEPRECATED;
+int roar_set_vol2     (struct roar_connection * con, int id, struct roar_mixer_settings * mixer, int   channels, int mode) _LIBROAR_CTL_STDATTRS;
+int roar_get_vol      (struct roar_connection * con, int id, struct roar_mixer_settings * mixer, int * channels) _LIBROAR_CTL_STDATTRS;
 
 // filter...
@@ -74,5 +76,5 @@
 #define roar_ctl_f2m_any(m) roar_ctl_f2m((m), ROAR_CTL_FILTER_ANY, ROAR_CTL_FILTER_ANY, ROAR_CTL_FILTER_ANY)
 
-int roar_filter_match (const unsigned cmp, const uint32_t a, const uint32_t b);
+int roar_filter_match (const unsigned cmp, const uint32_t a, const uint32_t b) _LIBROAR_ATTR_USE_RESULT _LIBROAR_ATTR_PURE;
 
 // int array
@@ -84,14 +86,14 @@
 int roar_ctl_m2c      (struct roar_message * m, struct roar_client * c);
 
-int    roar_str2proto (char * proto);
-char * roar_proto2str (int    proto);
+int    roar_str2proto (char * proto) _LIBROAR_ATTR_USE_RESULT _LIBROAR_ATTR_PURE;
+char * roar_proto2str (int    proto) _LIBROAR_ATTR_USE_RESULT _LIBROAR_ATTR_PURE;
 
-int    roar_str2byteorder (char * byteorder);
-char * roar_byteorder2str (int    byteorder);
+int    roar_str2byteorder (char * byteorder) _LIBROAR_ATTR_USE_RESULT _LIBROAR_ATTR_PURE;
+char * roar_byteorder2str (int    byteorder) _LIBROAR_ATTR_USE_RESULT _LIBROAR_ATTR_PURE;
 
-int    roar_str2ot        (const char * ot);
-const char * roar_ot2str  (const int    ot);
+int    roar_str2ot        (const char * ot) _LIBROAR_ATTR_USE_RESULT _LIBROAR_ATTR_PURE;
+const char * roar_ot2str  (const int    ot) _LIBROAR_ATTR_USE_RESULT _LIBROAR_ATTR_PURE;
 
-int roar_conv_volume (struct roar_mixer_settings * dst, struct roar_mixer_settings * src, int dstchans, int srcchans);
+int roar_conv_volume (struct roar_mixer_settings * dst, struct roar_mixer_settings * src, int dstchans, int srcchans) _LIBROAR_CTL_STDATTRS;
 
 #endif